//**************************************************************
//          Numerical Differentiation                     ******
//          using Forward Euler,    Backward Euler        ******
//          Central difference                            ******
//          By Manas,FOSSEE,IITB                          ******
//**************************************************************

//   Here f(x) = sin(x) at x = 1

hh = 2.^(-(1:10))
f = zeros(hh)
b = zeros(hh)
c1 = zeros(hh)
c2 = zeros(hh)

for j = 1:10
    h = hh(j)
    f(j) = (sin(1 + h) - sin(1))/h
    b(j) = (sin(1) - sin(1-h))/h
    c1(j) = (sin(1+h) - sin(1-h))/(2*h)
    c2(j) = (sin(1+h) - 2*sin(1) + sin(1-h))/(h^2)
end

f_err = abs(f - cos(1))
b_err = abs(b - cos(1))
c1_err = abs(c1 - cos(1))
c2_err = abs(c2 + sin(1))

subplot(2,2,1)
plot2d(log10(hh), log10(f_err))
title('Forward Euler Method')
subplot(2,2,2)
plot2d(log10(hh), log10(b_err))
title('Backward Euler Method')
subplot(2,2,3)
plot2d(log10(hh), log10(c1_err))
title('Central Difference Scheme')
subplot(2,2,4)
plot2d(log10(hh), log10(c2_err))
title('Second order derivative using Central Difference Scheme')
