// *****************************************************************
//       Newtons Method for System of Nonlinear Equations        ***
//           f1(x) = 0, f2(x) = 0, .....fn(x) = 0, x \in R^n     ***
//       NPDE-TCA UG-Level workshop at IMA Bhubaneshwar          ***
//       By Manas,FOSSEE,IITB                                    ***
//******************************************************************

funcprot(0)


function [x] = Newton_Sys(x0, f, J)
    
N = 100;
Tol = 1e-6;
Maxval = 1000;

xx = x0;

   mprintf("Iterations      x_n               y_n\n")
   mprintf("-------------------------------------------\n")
      
while (N > 0)
    JJ = J(xx);
    xv = xx - inv(JJ)*f(xx);        // Iteration formula
    if (abs(f(xv))< Tol) then      // Stopping Criteria
        x = xv;   
        return 
    end
    
        if (abs(f(xx))> Maxval) then

            error('The Solution Diverges')
            abort
        end
        
    N = N-1
    
  mprintf("%d             %f           %f\n",100-N, xx(1), xx(2))
     
    
    xx = xv;
    
  
end

 Root = x;
endfunction
