//**********************************************************************
//      Newton's method for finding a root of nonlinear equation    ****
//                         f(x) = 0;                                ****
//      NPDE-TCA UG-Level workshop at IMA Bhubaneshwar              ****
//      By Manas,FOSSEE,IITB                                        ****
//**********************************************************************

funcprot(0)

function [p]  =NewtonsMeth(x0,f,Df)
    
    N = 100;
    Tol = 1.e-7;
    Maxval = 1000;
    p0 = x0;
   
   mprintf("Iterations      p_n               p_{n+1}         |f(p_{n+1})|\n")
   mprintf("---------------------------------------------------------------------\n")
      
    
    while (N > 0)
        pn = p0 - f(p0)/Df(p0);      // Iteration formula 
        if (abs(f(pn)))< Tol then   //  Stopping Criteria
            p = pn;
            disp(100-N);
            return
        end
        
        if (abs(f(p0))> Maxval) then

            error('The Solution Diverges')
            abort
        end
        
   mprintf("%d             %f           %f          %f\n",100-N, p0, pn, abs(f(pn)))
        N = N-1;
        p0 = pn
    end
endfunction
