//*******************************************************
//  Gauss Elimination Method with partial pivoting  ****
//  for solving the system of linear equations      **** 
//                     AX = b                       ****      
//  NPDE-TCA  UG-Level Workshop at IMA Bhubaneshwar ****
//     By Manas,FOSSEE,IITB                         ****
//*******************************************************

format('e',20)

A=input("Enter the coeffiecient matrix of nxn: ")
b=input("Enter the right-hand side matrix nx1: ")

    function [x]=gaussian_partialpivoting(A,b)
        
//This function obtains the solutions to the system of linear equatons 
//A*x = b,given the matrix coefficients A and the right-hand side vector,b.   
//Gaussian elimination with partial pivoting
//     Inputs:
//A - matrix of real numbers of size nxn
//b - a right-hand side column vector.
//    Output: 
//x - the solution to the given equation.

//Retrieve the size of matrix A and vector b
            [n,n1]=size(A);
            [m1,p]=size(b);
    
//Check that size of A and size of b are compatible
            if n ~= n1
                error('gaussianelimination - Matrix A must be square');
            abort;
            elseif n ~= m1 
                error('gaussianelimination - incompatible dimension of A & b');
            abort;
            end;
//Create the augmented system C
            C=[A b]
            for i = 1:n-1
                [pivot,k]=max(abs(C(i:n,i)));
//k is position of pivot,relativ to row i
//Do not check above current row
            if k>1 then
                temp1=C(i,:);
                C(i,:)=C(i+k-1,:);
                C(i+k-1,:)=temp1;
            end
            m(i+1:n,i)=-C(i+1:n,i)/C(i,i);
            C(i+1:n,:)=C(i+1:n,:)+m(i+1:n,i)*C(i,:);
            end
//Back substitution
            x(n,1:p)=C(n,n+1:n+p)/C(n,n);
            for i = n-1:-1:1
                x(i,1:p)=(C(i,n+1:n+p)- C(i,i+1:n)*x(i+1:n,1:p))/C(i,i);
            end
    endfunction
