//*******************************************************
//  Gauss-Thomas Method                             ****
//  for solving the system of linear equations      **** 
//                     AX = b                       ****      
//  NPDE-TCA  UG-Level Workshop at IMA Bhubaneshwar ****
//     By Manas,FOSSEE,IITB                         ****
//*******************************************************
format('e',20)
A=input("Enter the tridiagonal matrix: ")
a=input("Enter the upper diagonal matrix of A: ")
d=input("Enter the diagonal matrix of A: ")
b=input("Enter the lower diagonal matrixof A: ")
r=input("Enter the right-hand side of the equation Ax=b: ")

    function [x] =thomas (a,d,b,r)
        
//Gauss-Thomas Method for Tridiagonal matrix
//calling sequences:
//             x = thomas ( a,d,b,r )
//             thomas ( a,d,b,r )
//
//Solve  Ax = b,where A is a tridiagonal matrix

//inputs:
//        A - coefficient matrix for linear system
//        a - upper diagonal of matrix A, a(n)=0
//        d - diagonal of matrix A
//        b - lower diagonal of matrix A, b(1)=0
//        r - right-hand side of equation

//        output:
 
//        x = solution for the linear system
    
            n= length(d);
            a(1)=a(1)/d(1);     //form the new elements a(1)
            r(1)=r(1)/d(1)     //form the new elements r(1)
            for i = 2:(n-1)   //Calculates a(i) & r(i) from i=2.....(n-1)
            denom = d(i)-b(i)*a(i-1);
        if(denom ==0)
            error('Zero in denominator')
        end;
            a(i)=a(i)/denom;
            r(i)=(r(i)-b(i)*r(i-1))/denom;
        end;
            r(n)=(r(n)-b(n)*r(n-1))/(d(n)-b(n)*a(n-1));    //Calculate r(n) for the last equation
            x(n)= r(n);
        for i = (n-1):-1:1    //Solves the equation by back substution
            x(i)=r(i)- a(i)*x(i+1);
        end
    endfunction
